import java.util.ArrayList;
import java.util.List;

public class Colect<T, S>
{
	public List<T> lista;
	
	// tworzenie obiektu typu Colect<T, S> zawierajacego w sobie liste elementow typu T
	public static <T,S> Colect<T,S> create(List<T> x)
	{
		Colect<T,S> tmp = new Colect<T,S>();
		tmp.lista = x;
		return tmp;
	}

	// usuwanie z listy elementy nie spelniajace wymagan
	public Colect<T,S> when(Select<T> x)
	{
		// usuwam z listy elementy nie przechodzace przez funkcje 'select' z podanego obiektu typu 'Select'
		for(int i = 0; i < lista.size(); i++)
		{
			T element = lista.get(i);
			if(!x.select(element))
			{
				lista.remove(i);
				// jesli usuwam 'aktualny' (lub wczesniejszy) element listy to musze zmniejszyc iterator o 1
				i--;
			}
		}
		return this;
	}

	// 
	public List<S> mapEvery(Mapper<T, S> mapInt)
	{
		// lista zwracana, inny typ niz przyjmowana (przyjmuje T i zwraca S)
		List<S> listaZwracana = new ArrayList<S>();
		for(int i = 0; i < lista.size(); i++)
		{
			// pobieram element listy
			T element = lista.get(i);
			
			// modyfikuje jego wartosc uzywajac funkcji 'map' z podanego 'Mapper'a
			// przy okazji typ zmienia sie z T na S
			S elementZmodyfikowany = mapInt.map(element);
			
			// zapisuje nowa wartosc w miejsce starej na liscie
			listaZwracana.add(elementZmodyfikowany);
		}
		return listaZwracana;
	}
}
