import java.util.ArrayList;
import java.util.List;


public class Main
{
	public static void main(String[] args)
	{
		// tworze liste typu Integer
		List<Integer> x = new ArrayList<Integer>();
		x.add(3);
		x.add(4);
		x.add(7);
		x.add(10);
		x.add(17);

		// usun liczby wieksze od 8
		Select<Integer> sel = new SelInt(8);
		// generowana lista ma zawierac wartosci powiekszone o 12
		Mapper<Integer, Integer> map = new MapIntegerDodaj(12);

		// generuje nowa liste - przefiltrowana i zmapowana
		List<Integer> result = Colect.<Integer,Integer>create(x).when(sel).mapEvery(map);
		for(Integer element : result)
		{
			System.out.println(element);
		}

		System.out.println();
		System.out.println();

		// tworze liste typu String
		List<String> y = new ArrayList<String>();
		y.add("a");
		y.add("bb");
		y.add("ccc");
		y.add("dddd");
		y.add("eeeee");
		y.add("ffffff");
		

		// usun slowa dluzsze niz 6 znakow
		Select<String> sel2 = new SelStr(6);
		// generowana lista ma zawierac INT z dlugoscia wyrazow powiekszona o 13
		Mapper<String, Integer> map2 = new MapStringDlugoscDodaj(13);

		// generuja nowa liste - przefiltrowana i zmapowana
		List<Integer> result2 = Colect.<String, Integer>create(y).when(sel2).mapEvery(map2);
		for(Integer element : result2)
		{
			System.out.println(element);
		}
	}
}
